/*	Copyright (c) 1991 Richard F. Man.  All rights reserved.
 *	man@labrea.zko.dec.com, P.O. Box 6, North Chelmsford, MA 01863
 *	tabstop=4
 *
 *	$Log: queue.c%v $
 * Revision 1.1  1991/12/08  22:12:48  rfm
 * Initial revision
 *
 *
 */
#include <stdlib.h>
#include "exec.h"
#include "execpriv.h"

/*	delete an item off a queue
 */
void QueDeleteQueue(QUEUE_HDR *pHdr, STRING_ATOM nameAtom)
	{
	QUEUE *pQueue, **qbQueue;

	/*	delete from the front
	 */
	if (nameAtom == pHdr->pFirst->nameAtom)
		pQueue = QueDeQueue(pHdr);
	/*	delete from the end
	 */
	else if (nameAtom == pHdr->pLast->nameAtom)
		{
		pQueue = pHdr->pLast;
		pHdr->pLast = pQueue->prev;
		if (pHdr->pFirst == pQueue)
			pHdr->pFirst = NULL;
		}
	/*	hard work
	 */
	else
		for (qbQueue = &pHdr->pFirst; pQueue = *qbQueue; 
				qbQueue = &(*qbQueue)->succ)
			{
			if (nameAtom == pQueue->nameAtom)
				{
				pQueue->succ->prev = pQueue->prev;
				*qbQueue = pQueue->succ;
				break;
				}
			}
	if (pQueue)
		free(pQueue);
	}

/*	take an item off the front of a queue
 */
void *QueDeQueue(QUEUE_HDR *pHdr)
    {
    QUEUE *pQueue;

    pQueue = pHdr->pFirst;
    pHdr->pFirst = pQueue->succ;
	if (pHdr->pFirst)
		pHdr->pFirst->prev = NULL;
    if (pHdr->pLast == pQueue)
        pHdr->pLast = NULL;
    return (pQueue);
    }

/*	check to see if a queue is empty
 */
BOOL QueEmpty(QUEUE_HDR *pHdr)
	{

	return (pHdr->pFirst == NULL);
	}

/*	put an item at the end of a queue
 */
void QueEnQueue(QUEUE_HDR *pHdr, void *p)
    {
    QUEUE *pQueue;

    pQueue = p;
	pQueue->succ = NULL;
    pQueue->prev = pHdr->pLast;
	if (pHdr->pLast)
		pHdr->pLast->succ = pQueue;
    pHdr->pLast = pQueue;
    if (!pHdr->pFirst)
        pHdr->pFirst = pQueue;
    }

/*	find an item in a queue
 */
void *QueFindItem(QUEUE_HDR *pHdr, STRING_ATOM nameAtom)
    {
    QUEUE *pQueue;

    for (pQueue = pHdr->pFirst; pQueue; pQueue = pQueue->succ)
        if (pQueue->nameAtom == nameAtom)
            return (pQueue);
    return (NULL);
    }

/*	call a function for each item in a queue
 */
void QueForeachQueueItem(QUEUE_HDR *pHdr, void (*pFunc)(void *p))
    {
    QUEUE *pQueue;

    for (pQueue = pHdr->pFirst; pQueue; pQueue = pQueue->succ)
        (*pFunc)(pQueue);
    }
